
(function(){
////

let HypeSceneLogicEnablerInstances = this.HypeSceneLogicEnablerInstances = {};
let HypeDocumentLogicEnablerInstances = this.HypeDocumentLogicEnablerInstances = {};


////
function HypeLogicEnabler_sceneUnload(hypeDocument, element, event){
HypeSceneLogicEnablerInstances = {};
}

////

function HypeLogicEnabler_sceneLoad(hypeDocument, element, event) {

const sceneEl = element;
const HypeLogicEnablerInstanceElements = [ ... sceneEl.querySelectorAll(".conditionalInstance") ];
//console.log(HypeLogicEnablerInstanceElements)

//iterate instances
HypeLogicEnablerInstanceElements.forEach(
(el) => {
const instanceProperties = {};
const instanceNamespace = el.dataset.logicNamespace || false;

if(!instanceNamespace)return;

instanceProperties.$if = el.dataset.logicIf || (instanceNamespace + ": logicIf not defined");
instanceProperties.$then = el.dataset.logicThen || (instanceNamespace + ": logicThen not defined");
instanceProperties.$else = el.dataset.logicElse || (instanceNamespace + ": logicElse not defined");
instanceProperties.$strict = el.dataset.logicModeStrict || false;
instanceProperties.$progress = [];
//instanceProperties.$length = (instanceProperties.$if.indexOf("_and_") !== -1) ? ((instanceProperties.$if.split("_and_")).length) : ((instanceProperties.$if.split("_or_")).length);

if(el.dataset.documentwide){
HypeDocumentLogicEnablerInstances[instanceNamespace] = instanceProperties;
/*console.log(instanceNamespace)
console.log(HypeDocumentLogicEnablerInstances[instanceNamespace])
console.log("")*/

}else{
HypeSceneLogicEnablerInstances[instanceNamespace] = instanceProperties;
/*console.log(instanceNamespace);
console.log(HypeSceneLogicEnablerInstances[instanceNamespace]);
console.log("");*/
}

}
)
//end of iteration
}



//////
function HypeLogicEnabler_customBehavior(hypeDocument, element, event) {


//////////helper functions
/////
function getLogicInstance(instanceName){
//documentwide instances will overwrite sceneinstances
return  HypeDocumentLogicEnablerInstances[instanceName] || HypeSceneLogicEnablerInstances[instanceName];
}
/////

//checks if two arrays of same length inherit the same elements solution/progress
function equals(arr1, arr2, logicInstance) {

let strictMode = (logicInstance.$strict) ? true : false;

let tmpArray = [];
arr1.forEach((arrayElement, index) => {

if(strictMode){

if(arrayElement === arr2[index]){
tmpArray.push(arrayElement);
}

}else{

const getIndex = arr2.indexOf(arrayElement);

if(getIndex != -1){
arr2.splice(getIndex, 1); 
tmpArray.push(arrayElement);
}

}

})


return (tmpArray.length === arr1.length)
}
/////

///
function solved(arr1, arr2){

let tmpArray = [];

arr1.forEach((arrayElement) => {

arr2.forEach((el) => {
if(arrayElement === el){tmpArray.push(el)}
})

})

if(tmpArray.length > 0){
return tmpArray.join("_")
}else{
return false
}

}

////
function getSolutionsArrayAndLogicDevider(conditions){
let solutionsArray, logicDevider;

const deviders = {
"and" : "_and_",
"or" : "_or_"
}

const andArray = conditions.split(deviders["and"]);
const orArray = conditions.split(deviders["or"]);

if(andArray.length > 1){
solutionsArray = andArray;
logicDevider = deviders["and"];
}else if(orArray.length > 1){
solutionsArray = orArray;
logicDevider = deviders["or"];
}

if(solutionsArray){
return [solutionsArray, logicDevider];
}else{
return [false, false];
}

}

/////


/////
function checkProgress(solutionsArray, logicDevider, progress, logicInstance)
{

if(logicDevider === "_and_"){
if(solutionsArray.length === progress.length){
const customBehaviorToExecute = equals(solutionsArray, progress, logicInstance) ? logicInstance.$then : logicInstance.$else;

hypeDocument.triggerCustomBehaviorNamed(customBehaviorToExecute);
console.log("customBehavior: " + customBehaviorToExecute)

//reset instance
logicInstance.$progress = [];
}

//check liveprogess of and-logic

if(solutionsArray.join('').indexOf(progress.join('')) != 0){
hypeDocument.triggerCustomBehaviorNamed(logicInstance.$else);
console.log("customBehavior: " + logicInstance.$else)

//reset instance
logicInstance.$progress = [];

}

}//end of _and_


if(logicDevider === "_or_"){
if(solutionsArray.length === progress.length){
let customBehaviorToExecute = solved(solutionsArray, progress);

if(!customBehaviorToExecute){customBehaviorToExecute = logicInstance.$else};

if(customBehaviorToExecute){
hypeDocument.triggerCustomBehaviorNamed(customBehaviorToExecute);
console.log("customBehavior: " + customBehaviorToExecute);
}

//reset instance
logicInstance.$progress = [];
}
}//end of _or_

}
/////

////////end helper functions

try{////////////////////////////

const customBehaviorName = event.customBehaviorName;

[instanceName, logicArgument] = customBehaviorName.split("|");

//logicaregument will be the second in the array, if there's no, it's not for us ... -> return
if(!logicArgument){return}

instanceName = instanceName.trim();
logicArgument = logicArgument.trim();


//instancename has to be unique
//an instance can belong to the documentlevel or scenelevel -> not both. 
const logicInstance = getLogicInstance(instanceName);


let progress = logicInstance.$progress;
progress.push(logicArgument);

const [solutionsArray, logicDevider] = getSolutionsArrayAndLogicDevider(logicInstance.$if);

if(!solutionsArray)return;


checkProgress(solutionsArray, logicDevider, progress, logicInstance)

/////////////////////////
}catch (e){/*console.log(e)*/}

}
//////
if("HYPE_eventListeners" in window === false) { window.HYPE_eventListeners = Array(); }
window.HYPE_eventListeners.push({"type":"HypeTriggerCustomBehavior", "callback":HypeLogicEnabler_customBehavior});
window.HYPE_eventListeners.push({"type":"HypeSceneLoad", "callback":HypeLogicEnabler_sceneLoad});
window.HYPE_eventListeners.push({"type":"HypeSceneUnload", "callback":HypeLogicEnabler_sceneUnload});

//////
})()
